import { Input, InputNumber, Space } from "../index";
import Preview from "./Preview";
import { resolveColor, transformColor } from "../ColorPicker/utils";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function Color(_ref) {
  var value = _ref.value,
    simple = _ref.simple,
    onChange = _ref.onChange;
  if (simple) {
    return /*#__PURE__*/_jsx(Preview, {
      value: value,
      onChange: onChange
    });
  }
  var handleOpacityChange = function handleOpacityChange(opacity) {
    var color = value;
    var _ref2 = resolveColor(color) || {},
      _ref2$hex = _ref2.hex,
      hex = _ref2$hex === void 0 ? '' : _ref2$hex;
    var newValue = transformColor(hex, opacity / 100);
    if (newValue) {
      onChange(newValue);
    }
  };
  var handleHexChange = function handleHexChange(hexParam) {
    var hex = hexParam.startsWith('#') ? hexParam : '#' + hexParam;
    hex = hex.toUpperCase();
    var hexReg = /^#([0-9|A-F]{3}|[0-9|A-F]{6})$/;
    if (!hexReg.test(hex)) {
      hex = '#000000';
    }
    var _ref3 = resolveColor(value) || {},
      a = _ref3.a;
    var newValue = transformColor(hex, a);
    if (newValue) {
      onChange(newValue);
    }
  };
  var color = value;
  var _ref4 = resolveColor(color) || {},
    _ref4$hex = _ref4.hex,
    hex = _ref4$hex === void 0 ? '' : _ref4$hex,
    _ref4$a = _ref4.a,
    a = _ref4$a === void 0 ? 0 : _ref4$a;
  var hexValue = hex.replace('#', '').toUpperCase();
  var opacityValue = Math.floor(a * 100);
  return /*#__PURE__*/_jsxs(Space, {
    children: [/*#__PURE__*/_jsx(Preview, {
      value: value,
      onChange: onChange
    }), /*#__PURE__*/_jsx(Input, {
      size: "small",
      prefix: "#",
      value: hexValue,
      onChange: handleHexChange
    }), /*#__PURE__*/_jsx(InputNumber, {
      size: "small",
      value: opacityValue,
      suffix: "%",
      min: 0,
      max: 100,
      style: {
        width: 64
      },
      onChange: handleOpacityChange
    })]
  });
}