import { memo, useMemo, useRef } from 'react';
import { Panel } from 'rc-color-picker';
import { useDebounceFn } from 'ahooks';
import Color from 'rc-color-picker/lib/helpers/color';
import 'rc-color-picker/assets/index.css';
import "./Panel.less";
import { jsx as _jsx } from "react/jsx-runtime";
export default /*#__PURE__*/memo(function ColorPickerPanel(_ref) {
  var _ref$color = _ref.color,
    color = _ref$color === void 0 ? 'rgba(255,0,255,0.5)' : _ref$color,
    onChange = _ref.onChange;
  var lastColor = useRef(color);
  var colorObj = new Color(color);
  useMemo(function () {
    lastColor.current = color;
  }, [color]);
  var _useDebounceFn = useDebounceFn(function (_ref2) {
      var changedColor = _ref2.color,
        alpha = _ref2.alpha;
      var isSameColor = new Color(changedColor).hex === new Color(lastColor.current).hex && new Color(changedColor).alpha === new Color(lastColor.current).alpha;
      if (isSameColor) {
        return;
      }
      var newColor;
      var rgbColor;
      if (alpha === 100) {
        newColor = changedColor;
      } else {
        rgbColor = new Color(changedColor).RGB;
        newColor = "RGBA(".concat(rgbColor[0], ",").concat(rgbColor[1], ",").concat(rgbColor[2], ",").concat(alpha / 100, ")");
      }
      onChange(newColor);
    }, {
      wait: 100,
      leading: true,
      trailing: false
    }),
    run = _useDebounceFn.run;
  return /*#__PURE__*/_jsx(Panel, {
    className: 'arco-color-picker-panel',
    color: colorObj.toHexString(),
    alpha: colorObj.alpha,
    mode: "RGB",
    onChange: run
  });
});