function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React, { useRef, useCallback } from 'react';
import classNames from 'classnames';
import { useEventListener } from 'ahooks';
import { getBackgroundAccordingColor, getMiddleColor } from "./utils";
import "./Points.less";
import { jsx as _jsx } from "react/jsx-runtime";
export default function Points(props) {
  var _props$dots = props.dots,
    dots = _props$dots === void 0 ? [] : _props$dots,
    active = props.active,
    setActive = props.setActive,
    onChange = props.onChange;
  var mouseDownRef = useRef(false);
  var containerRect = useRef({});
  var containerRef = useRef(null);
  var handleMouseDown = function handleMouseDown(index, e) {
    e.stopPropagation();
    mouseDownRef.current = true;
    containerRect.current = containerRef.current.getBoundingClientRect();
    setActive(index);
  };
  var handleMouseMove = function handleMouseMove(e) {
    e.stopPropagation();
    if (mouseDownRef.current) {
      var newOffset = (e.clientX - containerRect.current.x) / containerRect.current.width * 100;
      newOffset = newOffset > 100 ? 100 : newOffset < 0 ? 0 : newOffset;
      var newDots = dots.map(function (d, i) {
        return i === active ? _objectSpread(_objectSpread({}, d), {}, {
          offset: newOffset
        }) : d;
      });
      onChange(newDots);
    }
  };
  var handleMouseUp = useCallback(function (e) {
    e.stopPropagation();
    mouseDownRef.current = false;
  }, []);
  useEventListener('mousemove', handleMouseMove);
  useEventListener('mouseup', handleMouseUp);
  var handleAddColor = function handleAddColor(e) {
    if (mouseDownRef.current) {
      return;
    }
    var offset = Math.floor(e.nativeEvent.offsetX / e.target.offsetWidth * 100);
    var newColor = getMiddleColor(dots, offset);
    onChange(dots.concat({
      color: newColor,
      offset: offset
    }));
    setActive(dots.length);
  };
  return /*#__PURE__*/_jsx("div", {
    className: 'arco-color-picker-points-bar',
    style: getBackgroundAccordingColor(dots, 90),
    onMouseDown: handleAddColor,
    ref: containerRef,
    children: dots.map(function (dot, i) {
      return /*#__PURE__*/_jsx("span", {
        className: classNames('arco-color-picker-points-dot', {
          'arco-color-picker-points-dot-active': active === i
        }),
        style: {
          backgroundColor: dot.color,
          left: "".concat(dot.offset, "%")
        },
        onMouseDown: function onMouseDown(e) {
          return handleMouseDown(i, e);
        }
      }, i);
    })
  });
}