import classNames from 'classnames';
import tinycolor from 'tinycolor2';
import { useControlBlock } from "./hooks/useControlBlock";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function ControlBar(_ref) {
  var color = _ref.color,
    type = _ref.type,
    _onChange = _ref.onChange,
    _onChangeComplete = _ref.onChangeComplete;
  var x;
  if (type === 'alpha') {
    x = color.alpha;
  } else {
    x = color.hsv.h / 360;
  }
  var rgbColor = tinycolor(color.hsv).toRgbString();
  var _useControlBlock = useControlBlock({
      value: [x, 0],
      onChange: function onChange(value) {
        if (type === 'hue') {
          _onChange === null || _onChange === void 0 ? void 0 : _onChange(value[0] * 360);
        } else {
          _onChange === null || _onChange === void 0 ? void 0 : _onChange(value[0]);
        }
      },
      onChangeComplete: function onChangeComplete(value) {
        if (type === 'hue') {
          _onChangeComplete === null || _onChangeComplete === void 0 ? void 0 : _onChangeComplete(value[0] * 360);
        } else {
          _onChangeComplete === null || _onChangeComplete === void 0 ? void 0 : _onChangeComplete(value[0]);
        }
      }
    }),
    blockRef = _useControlBlock.blockRef,
    onMouseDown = _useControlBlock.onMouseDown;
  if (type === 'alpha') {
    return /*#__PURE__*/_jsx("div", {
      className: classNames("colors-picker-control-bar colors-picker-control-alpha"),
      children: /*#__PURE__*/_jsxs("div", {
        ref: blockRef,
        className: "colors-picker-control-bar-inner",
        style: {
          backgroundImage: "linear-gradient(to right, transparent, ".concat(rgbColor, ")")
        },
        onMouseDown: onMouseDown,
        children: [/*#__PURE__*/_jsx("div", {
          className: "colors-picker-control-bar-right-box",
          style: {
            backgroundColor: rgbColor
          }
        }), /*#__PURE__*/_jsx("div", {
          className: "colors-picker-handler",
          style: {
            left: "".concat(x * 100, "%")
          }
        })]
      })
    });
  }
  return /*#__PURE__*/_jsx("div", {
    className: classNames("colors-picker-control-bar colors-picker-control-hue"),
    children: /*#__PURE__*/_jsx("div", {
      ref: blockRef,
      className: "colors-picker-control-bar-inner",
      onMouseDown: onMouseDown,
      children: /*#__PURE__*/_jsx("div", {
        className: "colors-picker-handler",
        style: {
          left: "".concat(x * 100, "%")
        }
      })
    })
  });
}