function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
import { SwapOutlined } from '@easyv/react-icons';
import classNames from 'classnames';
import { getLinearGradientStyle, getMiddleColor } from "../utils";
import { useKeyPress } from 'ahooks';
import { useControlBlock } from "../hooks/useControlBlock";
import { useEffect, useRef } from 'react';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function LinearPointsBar(_ref) {
  var active = _ref.active,
    value = _ref.value,
    onSelect = _ref.onSelect,
    _onChange = _ref.onChange,
    _onChangeComplete = _ref.onChangeComplete;
  var currentIndexRef = useRef(active);
  var valueRef = useRef(value);
  useEffect(function () {
    currentIndexRef.current = active;
  }, [active]);
  useEffect(function () {
    valueRef.current = value;
  }, [value]);
  var handleDelete = function handleDelete() {
    if (value.stops.length <= 2) return;
    var newStops = _toConsumableArray(value.stops);
    newStops.splice(active, 1);
    _onChange === null || _onChange === void 0 ? void 0 : _onChange(_objectSpread(_objectSpread({}, value), {}, {
      stops: newStops
    }));
    _onChangeComplete === null || _onChangeComplete === void 0 ? void 0 : _onChangeComplete(_objectSpread(_objectSpread({}, value), {}, {
      stops: newStops
    }));
    handleSelect(Math.max(active - 1, 0));
  };
  var handleSelect = function handleSelect(newIndex) {
    currentIndexRef.current = newIndex;
    onSelect(newIndex);
  };
  useKeyPress('Backspace', function (e) {
    e.stopImmediatePropagation();

    // 过滤掉表单的删除
    if (e.target instanceof HTMLInputElement || e.target instanceof HTMLTextAreaElement) {
      return;
    }
    handleDelete();
  });
  var sortedStops = value.stops.concat().sort(function (a, b) {
    return a.offset - b.offset;
  });
  var _useControlBlock = useControlBlock({
      value: [-Infinity, 0],
      onChange: function onChange(val, e) {
        if (e.type === 'mousedown') {
          if (e.target !== blockRef.current) {
            var _e$target, _e$target$dataset;
            handleSelect(Number((_e$target = e.target) === null || _e$target === void 0 ? void 0 : (_e$target$dataset = _e$target.dataset) === null || _e$target$dataset === void 0 ? void 0 : _e$target$dataset.index));
          } else {
            var newStop = {
              offset: val[0] * 100,
              color: getMiddleColor(value.stops, val[0] * 100)
            };
            var newValue = _objectSpread(_objectSpread({}, value), {}, {
              stops: [].concat(_toConsumableArray(value.stops), [newStop])
            });
            valueRef.current = newValue;
            _onChange === null || _onChange === void 0 ? void 0 : _onChange(newValue);
            handleSelect(value.stops.length);
          }
        } else {
          _onChange === null || _onChange === void 0 ? void 0 : _onChange(_objectSpread(_objectSpread({}, value), {}, {
            stops: valueRef.current.stops.map(function (d, i) {
              return _objectSpread(_objectSpread({}, d), {}, {
                offset: i === currentIndexRef.current ? val[0] * 100 : d.offset
              });
            })
          }));
        }
      },
      onChangeComplete: function onChangeComplete(val) {
        _onChangeComplete === null || _onChangeComplete === void 0 ? void 0 : _onChangeComplete(_objectSpread(_objectSpread({}, value), {}, {
          stops: valueRef.current.stops.map(function (d, i) {
            return _objectSpread(_objectSpread({}, d), {}, {
              offset: i === currentIndexRef.current ? val[0] * 100 : d.offset
            });
          })
        }));
      }
    }),
    blockRef = _useControlBlock.blockRef,
    onMouseDown = _useControlBlock.onMouseDown;
  var handleRevert = function handleRevert() {
    var newStops = value.stops.map(function (d) {
      return _objectSpread(_objectSpread({}, d), {}, {
        offset: 100 - d.offset
      });
    });
    _onChange === null || _onChange === void 0 ? void 0 : _onChange(_objectSpread(_objectSpread({}, value), {}, {
      stops: newStops
    }));
    _onChangeComplete === null || _onChangeComplete === void 0 ? void 0 : _onChangeComplete(_objectSpread(_objectSpread({}, value), {}, {
      stops: newStops
    }));
  };
  return /*#__PURE__*/_jsxs("div", {
    className: "colors-picker-linear-points-bar-wrapper",
    children: [/*#__PURE__*/_jsxs("div", {
      className: "colors-picker-linear-points-bar",
      children: [/*#__PURE__*/_jsx("div", {
        className: "colors-picker-points-bar-prev-half",
        style: {
          backgroundColor: sortedStops[0].color
        }
      }), /*#__PURE__*/_jsx("div", {
        className: "colors-picker-points-bar-next-half",
        style: {
          backgroundColor: sortedStops[sortedStops.length - 1].color
        }
      }), /*#__PURE__*/_jsx("div", {}), /*#__PURE__*/_jsx("div", {
        ref: blockRef,
        className: "colors-picker-linear-points-bar-color",
        style: getLinearGradientStyle(_objectSpread(_objectSpread({}, value), {}, {
          angle: 90
        })),
        onMouseDown: onMouseDown,
        children: value === null || value === void 0 ? void 0 : value.stops.map(function (d, i) {
          return /*#__PURE__*/_jsx("div", {
            className: classNames('colors-picker-linear-point', {
              active: active === i
            }),
            style: {
              left: "".concat(d.offset, "%")
            },
            "data-index": i
          }, "".concat(d.color, "_").concat(i));
        })
      })]
    }), /*#__PURE__*/_jsx("div", {
      className: "colors-picker-linear-points-switch",
      onClick: handleRevert,
      children: /*#__PURE__*/_jsx(SwapOutlined, {})
    })]
  });
}