import classNames from 'classnames';
import { Tooltip } from '@arco-design/web-react';
import { jsx as _jsx } from "react/jsx-runtime";
var tooltipsMap = {
  pure: '纯色',
  pures: '多色',
  linear: '渐变'
};
export default function ColorTypeTabs(_ref) {
  var tabs = _ref.tabs,
    active = _ref.active,
    onChange = _ref.onChange;
  if (tabs.length === 1) {
    return null;
  }
  return /*#__PURE__*/_jsx("div", {
    className: "colors-picker-tabs",
    children: tabs.map(function (d) {
      return /*#__PURE__*/_jsx(Tooltip, {
        content: tooltipsMap[d],
        position: "top",
        children: /*#__PURE__*/_jsx("div", {
          className: classNames("colors-picker-tab colors-picker-tab-".concat(d), {
            active: active === d
          }),
          onClick: function onClick() {
            return onChange(d);
          }
        })
      }, d);
    })
  });
}