function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { LinearColorPanel } from "../LinearColorPicker";
import { PureColorPanel } from "../PureColorPicker";
import { PuresColorPanel } from "../PuresColorPicker";
import { RangeColorPanel } from "../RangeColorPicker";
import ColorTypeTabs from "./ColorTypeTab";
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function MixedPanel(_ref) {
  var type = _ref.type,
    value = _ref.value,
    disabledAlpha = _ref.disabledAlpha,
    onChange = _ref.onChange,
    onChangeComplete = _ref.onChangeComplete;
  var handleChange = function handleChange(type) {
    return function (newValue) {
      onChange === null || onChange === void 0 ? void 0 : onChange(_objectSpread(_objectSpread({}, value), {}, _defineProperty({}, type, newValue)));
    };
  };
  var handleChangeComplete = function handleChangeComplete(type) {
    return function (newValue) {
      onChangeComplete === null || onChangeComplete === void 0 ? void 0 : onChangeComplete(_objectSpread(_objectSpread({}, value), {}, _defineProperty({}, type, newValue)));
    };
  };
  var handleTypeChange = function handleTypeChange(newType) {
    onChange === null || onChange === void 0 ? void 0 : onChange(_objectSpread(_objectSpread({}, value), {}, {
      type: newType
    }));
    onChangeComplete === null || onChangeComplete === void 0 ? void 0 : onChangeComplete(_objectSpread(_objectSpread({}, value), {}, {
      type: newType
    }));
  };
  var renderPanel = function renderPanel() {
    switch (value.type) {
      case 'pure':
        {
          return /*#__PURE__*/_jsx(PureColorPanel, {
            value: value['pure'],
            disabledAlpha: disabledAlpha,
            onChange: handleChange('pure'),
            onChangeComplete: handleChangeComplete('pure')
          });
        }
      case 'pures':
        {
          return /*#__PURE__*/_jsx(PuresColorPanel, {
            value: value['pures'],
            disabledAlpha: disabledAlpha,
            onChange: handleChange('pures'),
            onChangeComplete: handleChangeComplete('pures')
          });
        }
      case 'linear':
        {
          return /*#__PURE__*/_jsx(LinearColorPanel, {
            value: value['linear'],
            disabledAlpha: disabledAlpha,
            onChange: handleChange('linear'),
            onChangeComplete: handleChangeComplete('linear')
          });
        }
      case 'range':
        {
          return /*#__PURE__*/_jsx(RangeColorPanel, {
            disabledAlpha: disabledAlpha,
            value: value['range'],
            onChange: handleChange('range'),
            onChangeComplete: handleChangeComplete('range')
          });
        }
      default:
        {
          console.error('unknown color picker type');
        }
    }
  };
  return /*#__PURE__*/_jsxs(_Fragment, {
    children: [/*#__PURE__*/_jsx(ColorTypeTabs, {
      tabs: type,
      active: value.type,
      onChange: handleTypeChange
    }), renderPanel()]
  });
}