import tinycolor from 'tinycolor2';
import { useControlBlock } from "./hooks/useControlBlock";
import { jsx as _jsx } from "react/jsx-runtime";
export default function Palette(_ref) {
  var color = _ref.color,
    _onChange = _ref.onChange,
    _onChangeComplete = _ref.onChangeComplete;
  var _color$hsv = color.hsv,
    h = _color$hsv.h,
    s = _color$hsv.s,
    v = _color$hsv.v;
  var rgbColor = tinycolor({
    h: h,
    s: 1,
    v: 1
  }).toRgbString();
  var _useControlBlock = useControlBlock({
      value: [s, 1 - v],
      onChange: function onChange(value) {
        return _onChange === null || _onChange === void 0 ? void 0 : _onChange(value[0], 1 - value[1]);
      },
      onChangeComplete: function onChangeComplete(value) {
        return _onChangeComplete === null || _onChangeComplete === void 0 ? void 0 : _onChangeComplete(value[0], 1 - value[1]);
      }
    }),
    blockRef = _useControlBlock.blockRef,
    onMouseDown = _useControlBlock.onMouseDown;
  return /*#__PURE__*/_jsx("div", {
    ref: blockRef,
    className: "colors-picker-palette",
    style: {
      backgroundColor: rgbColor
    },
    onMouseDown: onMouseDown,
    children: /*#__PURE__*/_jsx("div", {
      className: "colors-picker-handler",
      style: {
        top: "".concat((1 - v) * 100, "%"),
        left: "".concat(s * 100, "%")
      }
    })
  });
}