function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useEffect, useRef, useState } from 'react';
import tinycolor from 'tinycolor2';
import Palette from "./Palette";
import ControlBar from "./ControlBar";
import BlurInput from "../BlurInput";
import { getHexValue } from "./utils";
import Preview from "./common/Preview";
import { PipetteOutlined } from '@easyv/react-icons';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function Panel(_ref) {
  var disabledAlpha = _ref.disabledAlpha,
    propsColor = _ref.color,
    onChange = _ref.onChange,
    onChangeComplete = _ref.onChangeComplete;
  var _useState = useState(function () {
      return {
        hsv: tinycolor(propsColor).toHsv(),
        alpha: tinycolor(propsColor).getAlpha()
      };
    }),
    _useState2 = _slicedToArray(_useState, 2),
    color = _useState2[0],
    setColor = _useState2[1];
  useEffect(function () {
    if (propsColor) {
      setColor({
        hsv: tinycolor(propsColor).toHsv(),
        alpha: tinycolor(propsColor).getAlpha()
      });
    }
  }, [propsColor]);
  var _color$hsv = color.hsv,
    h = _color$hsv.h,
    s = _color$hsv.s,
    v = _color$hsv.v;
  var _tinycolor$toRgb = tinycolor(color.hsv).toRgb(),
    r = _tinycolor$toRgb.r,
    g = _tinycolor$toRgb.g,
    b = _tinycolor$toRgb.b;
  var colorString = tinycolor(color.hsv).setAlpha(color.alpha).toRgbString();
  var hexString = tinycolor(color.hsv).toHexString();
  var hexRef = useRef(null);
  var handleHsvChange = function handleHsvChange(hsv, complete) {
    setColor(_objectSpread(_objectSpread({}, color), {}, {
      hsv: hsv
    }));
    if (complete) {
      onChangeComplete === null || onChangeComplete === void 0 ? void 0 : onChangeComplete(tinycolor(_objectSpread(_objectSpread({}, hsv), {}, {
        a: color.alpha
      })).toRgbString());
    } else {
      onChange === null || onChange === void 0 ? void 0 : onChange(tinycolor(_objectSpread(_objectSpread({}, hsv), {}, {
        a: color.alpha
      })).toRgbString());
    }
  };
  var handleAlphaChange = function handleAlphaChange(alpha, complete) {
    setColor(_objectSpread(_objectSpread({}, color), {}, {
      alpha: alpha
    }));
    var value = tinycolor(_objectSpread(_objectSpread({}, color.hsv), {}, {
      a: alpha
    })).toRgbString();
    if (complete === 'all') {
      onChange === null || onChange === void 0 ? void 0 : onChange(value);
      onChangeComplete === null || onChangeComplete === void 0 ? void 0 : onChangeComplete(value);
    } else if (complete) {
      onChangeComplete === null || onChangeComplete === void 0 ? void 0 : onChangeComplete(value);
    } else {
      onChange === null || onChange === void 0 ? void 0 : onChange(value);
    }
  };
  var handleHexChange = function handleHexChange(val) {
    var hexVal = getHexValue(val);
    var hsv = tinycolor(hexVal).toHsv();
    var hexString = tinycolor(hsv).toHexString();
    hexRef.current.forceUpdate(hexString.slice(1).toUpperCase());
    setColor(_objectSpread(_objectSpread({}, color), {}, {
      hsv: hsv
    }));
    onChangeWithComplete(tinycolor(_objectSpread(_objectSpread({}, hsv), {}, {
      a: color.alpha
    })).toRgbString());
  };
  var handleRgbChange = function handleRgbChange(rgb) {
    var hsv = tinycolor(_objectSpread({
      r: r,
      g: g,
      b: b
    }, rgb)).toHsv();
    setColor(_objectSpread(_objectSpread({}, color), {}, {
      hsv: hsv
    }));
    onChangeWithComplete(tinycolor(_objectSpread(_objectSpread({}, hsv), {}, {
      a: color.alpha
    })).toRgbString());
  };
  var handleColorChange = function handleColorChange(color) {
    setColor({
      hsv: tinycolor(color).toHsv(),
      alpha: 1
    });
    onChangeWithComplete(color);
  };
  var onChangeWithComplete = function onChangeWithComplete(color) {
    onChange === null || onChange === void 0 ? void 0 : onChange(color);
    onChangeComplete === null || onChangeComplete === void 0 ? void 0 : onChangeComplete(color);
  };
  return /*#__PURE__*/_jsxs("div", {
    className: "colors-picker-panel",
    children: [/*#__PURE__*/_jsx(Palette, {
      color: color,
      onChange: function onChange(newS, newV) {
        return handleHsvChange({
          h: h,
          s: newS,
          v: newV
        });
      },
      onChangeComplete: function onChangeComplete(newS, newV) {
        return handleHsvChange({
          h: h,
          s: newS,
          v: newV
        }, true);
      }
    }), /*#__PURE__*/_jsxs("div", {
      className: "colors-picker-control-wrapper",
      children: [window.EyeDropper && /*#__PURE__*/_jsx("div", {
        className: "colors-picker-eye-dropper",
        onClick: function onClick() {
          var eyeDropper = new window.EyeDropper();
          eyeDropper.open().then(function (result) {
            var sRGBHex = result.sRGBHex;
            handleColorChange(sRGBHex);
          });
        },
        children: /*#__PURE__*/_jsx(PipetteOutlined, {})
      }), /*#__PURE__*/_jsxs("div", {
        className: "colors-picker-control-bars",
        children: [/*#__PURE__*/_jsx(ControlBar, {
          type: "hue",
          color: color,
          onChange: function onChange(newH) {
            return handleHsvChange({
              h: newH,
              s: s,
              v: v
            });
          },
          onChangeComplete: function onChangeComplete(newH) {
            return handleHsvChange({
              h: newH,
              s: s,
              v: v
            }, true);
          }
        }), !disabledAlpha && /*#__PURE__*/_jsx(ControlBar, {
          type: "alpha",
          color: color,
          onChange: handleAlphaChange,
          onChangeComplete: function onChangeComplete(val) {
            return handleAlphaChange(val, true);
          }
        })]
      }), /*#__PURE__*/_jsx(Preview, {
        type: "pure",
        color: colorString,
        size: 28
      })]
    }), /*#__PURE__*/_jsxs("div", {
      className: "colors-picker-input-wrapper",
      children: [/*#__PURE__*/_jsxs("div", {
        className: "colors-picker-input colors-picker-input-hex",
        children: [/*#__PURE__*/_jsx(BlurInput, {
          size: "small",
          ref: hexRef,
          value: hexString.slice(1).toUpperCase(),
          validate: function validate(val) {
            return /^#?([0-9a-fA-F])+/.test(val);
          },
          onChange: handleHexChange
        }), /*#__PURE__*/_jsx("span", {
          className: "colors-picker-input-label",
          children: "Hex"
        })]
      }), /*#__PURE__*/_jsxs("div", {
        className: "colors-picker-input colors-picker-input-r",
        children: [/*#__PURE__*/_jsx(BlurInput, {
          size: "small",
          value: r.toString(),
          validate: function validate(val) {
            return +val >= 0 && +val <= 255;
          },
          onChange: function onChange(val) {
            return handleRgbChange({
              r: +val
            });
          }
        }), /*#__PURE__*/_jsx("span", {
          className: "colors-picker-input-label",
          children: "R"
        })]
      }), /*#__PURE__*/_jsxs("div", {
        className: "colors-picker-input colors-picker-input-g",
        children: [/*#__PURE__*/_jsx(BlurInput, {
          size: "small",
          value: g.toString(),
          validate: function validate(val) {
            return +val >= 0 && +val <= 255;
          },
          onChange: function onChange(val) {
            return handleRgbChange({
              g: +val
            });
          }
        }), /*#__PURE__*/_jsx("span", {
          className: "colors-picker-input-label",
          children: "G"
        })]
      }), /*#__PURE__*/_jsxs("div", {
        className: "colors-picker-input colors-picker-input-b",
        children: [/*#__PURE__*/_jsx(BlurInput, {
          size: "small",
          value: b.toString(),
          validate: function validate(val) {
            return +val >= 0 && +val <= 255;
          },
          onChange: function onChange(val) {
            return handleRgbChange({
              b: +val
            });
          }
        }), /*#__PURE__*/_jsx("span", {
          className: "colors-picker-input-label",
          children: "B"
        })]
      }), !disabledAlpha && /*#__PURE__*/_jsxs("div", {
        className: "colors-picker-input colors-picker-input-a",
        children: [/*#__PURE__*/_jsx(BlurInput, {
          size: "small",
          value: (color.alpha * 100).toFixed(0),
          validate: function validate(val) {
            return +val >= 0 && +val <= 100;
          },
          onChange: function onChange(val) {
            return handleAlphaChange(+val / 100, 'all');
          }
        }), /*#__PURE__*/_jsx("span", {
          className: "colors-picker-input-label",
          children: "A"
        })]
      })]
    })]
  });
}