import { useRef } from 'react';
import tinycolor from 'tinycolor2';
import BlurInput from "../../BlurInput";
import { getHexValue } from "../utils";
import Preview from "../common/Preview";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function PureColorInput(_ref) {
  var disabledAlpha = _ref.disabledAlpha,
    value = _ref.value,
    onChange = _ref.onChange,
    onTrigger = _ref.onTrigger;
  var hexRef = useRef(null);
  var hexString = tinycolor(value).toHexString();
  var alpha = disabledAlpha ? 1 : tinycolor(value).getAlpha();
  var handleHexChange = function handleHexChange(val) {
    var hexVal = getHexValue(val);
    var hsv = tinycolor(hexVal).toHsv();
    var hexString = tinycolor(hsv).toHexString();
    hexRef.current.forceUpdate(hexString.slice(1).toUpperCase());
    var newColor = tinycolor(hexString).setAlpha(alpha).toRgbString();
    onChange === null || onChange === void 0 ? void 0 : onChange(newColor);
  };
  var handleAlphaChange = function handleAlphaChange(val) {
    var newColor = tinycolor(hexString).setAlpha(val).toRgbString();
    onChange === null || onChange === void 0 ? void 0 : onChange(newColor);
  };
  return /*#__PURE__*/_jsxs("div", {
    className: "pure-color-picker",
    children: [/*#__PURE__*/_jsxs("div", {
      className: "pure-color-picker-input-wrap",
      children: [/*#__PURE__*/_jsx("div", {
        className: "pure-color-picker-preview",
        onClick: onTrigger,
        children: /*#__PURE__*/_jsx(Preview, {
          type: "pure",
          shape: "square",
          color: value,
          size: 12
        })
      }), /*#__PURE__*/_jsx(BlurInput, {
        className: 'pure-color-picker-hex',
        size: "small",
        ref: hexRef,
        prefix: "#",
        value: hexString.slice(1).toUpperCase(),
        validate: function validate(val) {
          return /^#?([0-9a-fA-F])+/.test(val);
        },
        onChange: handleHexChange
      })]
    }), !disabledAlpha && /*#__PURE__*/_jsx(BlurInput, {
      size: "small",
      suffix: "%",
      className: 'pure-color-picker-alpha',
      value: (alpha * 100).toFixed(0),
      validate: function validate(val) {
        return +val >= 0 && +val <= 100;
      },
      onChange: function onChange(val) {
        return handleAlphaChange(+val / 100);
      }
    })]
  });
}