import { useKeyPress } from 'ahooks';
import { PlusOutlined } from '@easyv/react-icons';
import { classPrefix } from '.';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function PuresCards(_ref) {
  var active = _ref.active,
    value = _ref.value,
    onAdd = _ref.onAdd,
    onDelete = _ref.onDelete,
    onSelect = _ref.onSelect;
  useKeyPress('Backspace', function (e) {
    e.stopImmediatePropagation();

    // 过滤掉表单的删除
    if (e.target instanceof HTMLInputElement || e.target instanceof HTMLTextAreaElement) {
      return;
    }
    onDelete();
  });
  return /*#__PURE__*/_jsxs("div", {
    className: "".concat(classPrefix, "-cards"),
    children: [value.map(function (d, i) {
      return /*#__PURE__*/_jsx("div", {
        className: "".concat(classPrefix, "-card"),
        onClick: function onClick() {
          return onSelect(i);
        },
        style: {
          backgroundColor: d,
          borderColor: active === i ? '#fff' : 'transparent'
        }
      }, "".concat(d, "_").concat(i));
    }), /*#__PURE__*/_jsx("div", {
      className: "".concat(classPrefix, "-add"),
      onClick: onAdd,
      children: /*#__PURE__*/_jsx(PlusOutlined, {})
    })]
  });
}