function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useEffect, useRef, useState } from 'react';
import Panel from "../Panel";
import History from "../History";
import PuresCards from "./PuresCards";
import useHistory from "./useHistory";
import tinycolor from 'tinycolor2';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function PuresColorPanel(_ref) {
  var disabledAlpha = _ref.disabledAlpha,
    value = _ref.value,
    onChange = _ref.onChange,
    onChangeComplete = _ref.onChangeComplete;
  var _useState = useState(0),
    _useState2 = _slicedToArray(_useState, 2),
    currentIndex = _useState2[0],
    setCurrentIndex = _useState2[1];
  var _useState3 = useState(0),
    _useState4 = _slicedToArray(_useState3, 2),
    updateKey = _useState4[0],
    setUpdateKey = _useState4[1];
  var panelRef = useRef(null);
  useEffect(function () {
    var _panelRef$current;
    (_panelRef$current = panelRef.current) === null || _panelRef$current === void 0 ? void 0 : _panelRef$current.focus();
  }, []);
  useHistory({
    value: value,
    active: currentIndex
  });
  var handleChange = function handleChange(color) {
    var newValue = _toConsumableArray(value);
    newValue[currentIndex] = color;
    onChange === null || onChange === void 0 ? void 0 : onChange(newValue);
  };
  var handleChangeComplete = function handleChangeComplete(color) {
    var newValue = _toConsumableArray(value);
    newValue[currentIndex] = color;
    onChangeComplete === null || onChangeComplete === void 0 ? void 0 : onChangeComplete(newValue);
  };
  var handleAdd = function handleAdd() {
    onChange === null || onChange === void 0 ? void 0 : onChange(value.concat('#000000'));
    onChangeComplete === null || onChangeComplete === void 0 ? void 0 : onChangeComplete(value.concat('#000000'));
    setCurrentIndex(value.length);
    setUpdateKey(updateKey + 1);
  };
  var handleDelete = function handleDelete() {
    if (value.length > 1) {
      onChange === null || onChange === void 0 ? void 0 : onChange(value.filter(function (_, index) {
        return index !== currentIndex;
      }));
      onChangeComplete === null || onChangeComplete === void 0 ? void 0 : onChangeComplete(value.filter(function (_, index) {
        return index !== currentIndex;
      }));
      setCurrentIndex(currentIndex > 0 ? currentIndex - 1 : 0);
      setUpdateKey(updateKey + 1);
    }
  };
  var handleSelect = function handleSelect(index) {
    setCurrentIndex(index);
    setUpdateKey(updateKey + 1);
  };
  var handleHistorySelect = function handleHistorySelect(val) {
    var newVal = val;
    if (disabledAlpha) {
      newVal = tinycolor(newVal).setAlpha(1).toHexString();
    }
    var newValue = _toConsumableArray(value);
    newValue[currentIndex] = newVal;
    onChange === null || onChange === void 0 ? void 0 : onChange(newValue);
    onChangeComplete === null || onChangeComplete === void 0 ? void 0 : onChangeComplete(newValue);
    setUpdateKey(updateKey + 1);
  };
  return /*#__PURE__*/_jsxs("div", {
    tabIndex: 1,
    id: "pures-colors-panel",
    ref: panelRef,
    children: [/*#__PURE__*/_jsx(PuresCards, {
      active: currentIndex,
      value: value,
      onAdd: handleAdd,
      onDelete: handleDelete,
      onSelect: handleSelect
    }), /*#__PURE__*/_jsx(Panel, {
      disabledAlpha: disabledAlpha,
      color: value[currentIndex],
      onChange: handleChange,
      onChangeComplete: handleChangeComplete
    }, updateKey), /*#__PURE__*/_jsx(History, {
      type: "pure",
      onSelect: handleHistorySelect
    })]
  });
}