function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useState } from 'react';
import Panel from "../Panel";
import History from "../History";
import RangePointsBar from "./RangePointBar";
import tinycolor from 'tinycolor2';
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function RangeColorPanel(_ref) {
  var value = _ref.value,
    disabledAlpha = _ref.disabledAlpha,
    onChange = _ref.onChange,
    onChangeComplete = _ref.onChangeComplete;
  var _useState = useState(0),
    _useState2 = _slicedToArray(_useState, 2),
    currentIndex = _useState2[0],
    setCurrentIndex = _useState2[1];
  var _useState3 = useState(0),
    _useState4 = _slicedToArray(_useState3, 2),
    updateKey = _useState4[0],
    setUpdateKey = _useState4[1];
  var handleChange = function handleChange(newValue, complete) {
    var newValueArray = _toConsumableArray(value);
    newValueArray[currentIndex] = newValue;
    if (complete) {
      onChangeComplete === null || onChangeComplete === void 0 ? void 0 : onChangeComplete(newValueArray);
    } else {
      onChange === null || onChange === void 0 ? void 0 : onChange(newValueArray);
    }
  };
  var handleSelect = function handleSelect(val) {
    var newValue = val;
    if (disabledAlpha) {
      newValue = tinycolor(newValue).setAlpha(1).toHexString();
    }
    handleChange(newValue, true);
    setUpdateKey(function (prev) {
      return prev + 1;
    });
  };
  var handleIndexSelect = function handleIndexSelect(index) {
    setCurrentIndex(index);
    setUpdateKey(function (prev) {
      return prev + 1;
    });
  };
  return /*#__PURE__*/_jsxs(_Fragment, {
    children: [/*#__PURE__*/_jsx(RangePointsBar, {
      active: currentIndex,
      value: value,
      onSelect: handleIndexSelect
    }), /*#__PURE__*/_jsx(Panel, {
      disabledAlpha: disabledAlpha,
      color: value[currentIndex],
      onChange: handleChange,
      onChangeComplete: function onChangeComplete(val) {
        return handleChange(val, true);
      }
    }, updateKey), /*#__PURE__*/_jsx(History, {
      type: "pure",
      onSelect: handleSelect
    })]
  });
}