import classNames from 'classnames';
import { getLinearGradientStyle } from "../utils";
import { jsx as _jsx } from "react/jsx-runtime";
export default function Preview(_ref) {
  var type = _ref.type,
    color = _ref.color,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? 20 : _ref$size,
    _ref$shape = _ref.shape,
    shape = _ref$shape === void 0 ? 'circle' : _ref$shape,
    border = _ref.border,
    onClick = _ref.onClick;
  // 处理不同类型的背景色
  var getColorStyle = function getColorStyle() {
    switch (type) {
      case 'pure':
        {
          return {
            backgroundColor: color
          };
        }
      case 'linear':
        {
          return getLinearGradientStyle(color);
        }
      case 'range':
        {
          var linearValue = {
            stops: [{
              offset: 0,
              color: color[0]
            }, {
              offset: 100,
              color: color[1]
            }],
            angle: 90,
            opacity: 1
          };
          return getLinearGradientStyle(linearValue);
        }
      default:
        return {};
    }
  };
  return /*#__PURE__*/_jsx("div", {
    className: classNames('colors-picker-preview', "colors-picker-preview-".concat(shape), {
      'colors-picker-preview-border': border
    }),
    style: {
      width: size,
      height: size,
      cursor: onClick ? 'pointer' : 'default'
    },
    onClick: onClick,
    children: /*#__PURE__*/_jsx("div", {
      className: "colors-picker-preview-color",
      style: getColorStyle()
    })
  });
}