function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useRef, useState } from 'react';
export function useControlBlock(_ref) {
  var value = _ref.value,
    onChange = _ref.onChange,
    onChangeComplete = _ref.onChangeComplete;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    active = _useState2[0],
    setActive = _useState2[1];
  var blockRef = useRef(null);
  var getPercentNumber = function getPercentNumber(value, max) {
    if (value < 0) {
      return 0;
    }
    if (value > max) {
      return 1;
    }
    return value / max;
  };
  var setCurrentPosition = function setCurrentPosition(ev) {
    var clientX = ev.clientX,
      clientY = ev.clientY;
    var rect = blockRef.current.getBoundingClientRect();
    var newValue = [getPercentNumber(clientX - rect.x, rect.width), getPercentNumber(clientY - rect.y, rect.height)];
    if (newValue[0] !== value[0] || newValue[1] !== value[1]) {
      if (ev.type === 'mouseup') {
        onChangeComplete === null || onChangeComplete === void 0 ? void 0 : onChangeComplete(newValue);
      } else {
        onChange === null || onChange === void 0 ? void 0 : onChange(newValue, ev);
      }
    }
  };
  function onMouseMove(ev) {
    ev.preventDefault();
    if (ev.buttons > 0) {
      setCurrentPosition(ev);
    } else {
      removeListener();
    }
  }
  var removeListener = function removeListener(e) {
    if ((e === null || e === void 0 ? void 0 : e.type) === 'mouseup') {
      setCurrentPosition(e);
    }
    setActive(false);
    window.removeEventListener('mousemove', onMouseMove);
    window.removeEventListener('mouseup', removeListener);
    window.removeEventListener('contextmenu', removeListener);
  };
  var onMouseDown = function onMouseDown(ev) {
    ev.stopPropagation();
    setActive(true);
    setCurrentPosition(ev);
    window.addEventListener('mousemove', onMouseMove);
    window.addEventListener('mouseup', removeListener);
    window.addEventListener('contextmenu', removeListener);
  };
  return {
    active: active,
    blockRef: blockRef,
    onMouseDown: onMouseDown
  };
}