function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
import tinycolor from 'tinycolor2';
export function toHex(x) {
  return ('0' + parseInt(x + '').toString(16)).slice(-2);
}
export function resolveColor(colorParam) {
  if (!colorParam || typeof colorParam !== 'string') {
    return {
      r: 255,
      g: 255,
      b: 255,
      a: 1,
      hex: '#ffffff'
    };
  }

  // 转为小写并去除空格
  // const color = colorParam.toLowerCase().replace(/\s+/g, '');
  // const hexReg = /^#([0-9|a-f]{3}|[0-9|a-f]{6})$/;
  // const rgbReg = /^(rgb\(\d+,\d+,\d+\)|rgba\(\d+,\d+,\d+,(\d+)?(\.)?(\d+)?\))$/;

  // let r, g, b, a;
  // if (hexReg.test(color)) {
  //   if (color.length === 4) {
  //     r = parseInt(color.slice(1, 2) + color.slice(1, 2), 16);
  //     g = parseInt(color.slice(2, 3) + color.slice(2, 3), 16);
  //     b = parseInt(color.slice(3, 4) + color.slice(3, 4), 16);
  //   } else {
  //     r = parseInt(color.slice(1, 3), 16);
  //     g = parseInt(color.slice(3, 5), 16);
  //     b = parseInt(color.slice(5, 7), 16);
  //   }
  //   a = 1;
  // } else if (rgbReg.test(color)) {
  //   let colors = color.replace(/rgba|rgb|\(|\)/g, '').split(',');
  //   r = Number(colors[0]);
  //   g = Number(colors[1]);
  //   b = Number(colors[2]);
  //   a = colors.length === 4 ? Number(colors[3]) : 1;
  // } else {
  //   return {};
  // }

  var _tinycolor$toRgb = tinycolor(colorParam).toRgb(),
    r = _tinycolor$toRgb.r,
    g = _tinycolor$toRgb.g,
    b = _tinycolor$toRgb.b,
    a = _tinycolor$toRgb.a;
  return {
    r: r,
    g: g,
    b: b,
    a: a,
    hex: "#".concat(toHex(r)).concat(toHex(g)).concat(toHex(b))
  };
}
export function transformColor(color, a) {
  var _resolveColor = resolveColor(color),
    r = _resolveColor.r,
    g = _resolveColor.g,
    b = _resolveColor.b,
    hex = _resolveColor.hex;
  return a === 1 ? hex : "RGBA(".concat(r, ",").concat(g, ",").concat(b, ",").concat(a, ")");
}
export function getBackgroundAccordingColor(color, fixedAngle) {
  if (typeof color === 'string') {
    return {
      background: color
    };
  } else if (Array.isArray(color)) {
    var rebaseStops = color.concat();
    rebaseStops.sort(function (a, b) {
      return a.offset - b.offset;
    });
    var colors = rebaseStops.map(function (item, index) {
      var _resolveColor2 = resolveColor(item.color),
        r = _resolveColor2.r,
        g = _resolveColor2.g,
        b = _resolveColor2.b,
        a = _resolveColor2.a;
      if (a === 1 || index === rebaseStops.length - 1) {
        return "".concat(item.color, " ").concat(item.offset, "%");
      } else {
        var _resolveColor3 = resolveColor(rebaseStops[index + 1].color),
          nextR = _resolveColor3.r,
          nextG = _resolveColor3.g,
          nextB = _resolveColor3.b,
          nextA = _resolveColor3.a;
        var stepOpacity = (nextA - a) / 5;
        var stepOffset = (rebaseStops[index + 1].offset - item.offset) / 5;
        var stepR = (nextR - r) / 5;
        var stepG = (nextG - g) / 5;
        var stepB = (nextB - b) / 5;
        return Array.from({
          length: 5
        }).map(function (d, i) {
          return "".concat(transformColor("rgb(".concat(Math.round(r + stepR * i), ",").concat(Math.round(g + stepG * i), ",").concat(Math.round(b + stepB * i), ")"), a + stepOpacity * i), " ").concat(item.offset + stepOffset * i, "%");
        }).join(',');
      }
    });
    return {
      backgroundImage: "linear-gradient(".concat(fixedAngle || 0, "deg, ").concat(colors.join(','), ")")
    };
  } else if (_typeof(color) === 'object') {
    var _color$type = color.type,
      type = _color$type === void 0 ? 'pure' : _color$type,
      _color$linear = color.linear,
      _color$linear2 = _color$linear === void 0 ? {
        stops: [{
          offset: 0,
          color: '#000'
        }, {
          offset: 100,
          color: '#fff'
        }],
        angle: 0,
        opacity: 1
      } : _color$linear,
      stops = _color$linear2.stops,
      angle = _color$linear2.angle,
      opacity = _color$linear2.opacity,
      _color$pure = color.pure,
      pureColor = _color$pure === void 0 ? '#000' : _color$pure;
    if (type === 'linear') {
      var _rebaseStops = stops.concat();
      _rebaseStops.sort(function (a, b) {
        return a.offset - b.offset;
      });
      var _colors = _rebaseStops.map(function (item, index) {
        var _resolveColor4 = resolveColor(item.color),
          r = _resolveColor4.r,
          g = _resolveColor4.g,
          b = _resolveColor4.b,
          a = _resolveColor4.a;
        if (a === 1 || index === _rebaseStops.length - 1) {
          return "".concat(transformColor(item.color, a * opacity), " ").concat(item.offset, "%");
        } else {
          var _resolveColor5 = resolveColor(_rebaseStops[index + 1].color),
            nextR = _resolveColor5.r,
            nextG = _resolveColor5.g,
            nextB = _resolveColor5.b,
            nextA = _resolveColor5.a;
          var stepOpacity = (nextA - a) / 5;
          var stepOffset = (_rebaseStops[index + 1].offset - item.offset) / 5;
          var stepR = (nextR - r) / 5;
          var stepG = (nextG - g) / 5;
          var stepB = (nextB - b) / 5;
          return Array.from({
            length: 5
          }).map(function (d, i) {
            return "".concat(transformColor("rgb(".concat(Math.round(r + stepR * i), ",").concat(Math.round(g + stepG * i), ",").concat(Math.round(b + stepB * i), ")"), (a + stepOpacity * i) * opacity), " ").concat(item.offset + stepOffset * i, "%");
          }).join(',');
        }
      });
      return {
        backgroundImage: "linear-gradient(".concat(fixedAngle ? fixedAngle : angle, "deg, ").concat(_colors.join(','), ")")
      };
    } else {
      return {
        background: pureColor
      };
    }
  }
}
export function getMiddleColor(colors, offset) {
  var leftColor, rightColor;
  var leftColors = colors.filter(function (d) {
    return d.offset < offset;
  });
  var rightColors = colors.filter(function (d) {
    return d.offset > offset;
  });
  if (leftColors.length) {
    leftColors.sort(function (a, b) {
      return b.offset - a.offset;
    });
    leftColor = leftColors[0];
  }
  if (rightColors.length) {
    rightColors.sort(function (a, b) {
      return a.offset - b.offset;
    });
    rightColor = rightColors[0];
  }
  if (!leftColor) {
    return rightColor.color;
  }
  if (!rightColor) {
    return leftColor.color;
  }
  var _resolveColor6 = resolveColor(leftColor.color),
    leftR = _resolveColor6.r,
    leftG = _resolveColor6.g,
    leftB = _resolveColor6.b,
    leftA = _resolveColor6.a;
  var _resolveColor7 = resolveColor(rightColor.color),
    rightR = _resolveColor7.r,
    rightG = _resolveColor7.g,
    rightB = _resolveColor7.b,
    rightA = _resolveColor7.a;
  var newR = Math.round((rightR - leftR) / (rightColor.offset - leftColor.offset) * (offset - leftColor.offset) + leftR);
  var newG = Math.round((rightG - leftG) / (rightColor.offset - leftColor.offset) * (offset - leftColor.offset) + leftG);
  var newB = Math.round((rightB - leftB) / (rightColor.offset - leftColor.offset) * (offset - leftColor.offset) + leftB);
  var newA = (rightA - leftA) / (rightColor.offset - leftColor.offset) * (offset - leftColor.offset) + leftA;
  return newA === 1 ? "#".concat(toHex(newR)).concat(toHex(newG)).concat(toHex(newB)) : "RGBA(".concat(newR, ",").concat(newG, ",").concat(newB, ",").concat(newA, ")");
}
export function getHexValue(hex) {
  var result = hex.replace(/^#/, '');
  if (result.length === 1) {
    result = result.repeat(6);
  } else if (result.length === 2) {
    result = result.repeat(3);
  } else if (result.length === 3) {
    result = result.replace(/(\w)(\w)(\w)/, '$1$1$2$2$3$3');
  } else if (result.length === 4 || result.length === 5) {
    result = result.slice(0, 3).replace(/(\w)(\w)(\w)/, '$1$1$2$2$3$3');
  } else if (result.length > 6) {
    result = result.slice(0, 6);
  }
  return '#' + result;
}
export function getLinearGradientStyle(color) {
  var stops = color.stops,
    _color$angle = color.angle,
    angle = _color$angle === void 0 ? 0 : _color$angle,
    _color$opacity = color.opacity,
    opacity = _color$opacity === void 0 ? 1 : _color$opacity;
  var sortedColors = stops.concat().sort(function (a, b) {
    return a.offset - b.offset;
  });
  var linearString = sortedColors.map(function (d) {
    return "".concat(tinycolor(d.color).toRgbString(), " ").concat(d.offset, "%");
  }).join(', ');
  return {
    backgroundImage: "linear-gradient(".concat(angle, "deg, ").concat(linearString, ")"),
    opacity: opacity
  };
}