import React from 'react';
import { Input } from '@arco-design/web-react';
import type { InputProps, InputSearchProps, RefInputType, RefTextAreaType, TextAreaProps } from './interface';
import './index.less';
declare type XInputType = React.ForwardRefExoticComponent<InputProps & React.RefAttributes<RefInputType>> & {
    Search: typeof InputSearch;
    TextArea: typeof InputTextArea;
    Password: typeof Input.Password;
    Group: typeof Input.Group;
};
declare const XInput: XInputType;
declare const InputSearch: React.ForwardRefExoticComponent<InputSearchProps & React.RefAttributes<RefInputType>>;
declare const InputTextArea: React.ForwardRefExoticComponent<TextAreaProps & React.RefAttributes<RefTextAreaType>>;
export default XInput;
export { InputProps, InputSearchProps, RefInputType };
export type * from './interface';
