function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["value", "defaultValue", "enableEmpty", "autoSelect", "changeOnBlur", "bordered", "className", "onPressEnter", "onFocus", "onBlur", "onChange"],
  _excluded2 = ["onSearch"],
  _excluded3 = ["value", "defaultValue", "changeOnBlur", "bordered", "className", "enableEmpty", "onBlur", "onChange"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useCallback, useEffect, useRef, useState } from 'react';
import { Input } from '@arco-design/web-react';
import { SearchCircleOutlined } from '@easyv/react-icons';
import classNames from 'classnames';
import "./index.less";
import { jsx as _jsx } from "react/jsx-runtime";
var XInput = /*#__PURE__*/forwardRef(function (props, ref) {
  var _halfControlledProps;
  var value = props.value,
    defaultValue = props.defaultValue,
    enableEmpty = props.enableEmpty,
    autoSelect = props.autoSelect,
    changeOnBlur = props.changeOnBlur,
    _props$bordered = props.bordered,
    bordered = _props$bordered === void 0 ? true : _props$bordered,
    className = props.className,
    onPressEnter = props.onPressEnter,
    onFocus = props.onFocus,
    onBlur = props.onBlur,
    onChange = props.onChange,
    restProps = _objectWithoutProperties(props, _excluded);

  // 用于 changeOnBlur 为 true 的模式，组件内存储，在失焦的时候，提交这个值
  var _useState = useState('value' in props ? value : defaultValue),
    _useState2 = _slicedToArray(_useState, 2),
    localValue = _useState2[0],
    setLocalValue = _useState2[1];

  // 为了让 onBlur 函数不要每次值更新都生成新的函数引用，这里用 ref 缓存 localValue 值，这样 onBlur 函数可以不依赖 localValue 的更新，直接在需要的时候读取 ref 的值
  var refValue = useRef(localValue);
  refValue.current = localValue;
  useEffect(function () {
    // 只在 changeOnBlur 为 true 的时候 value 变化才更新，防止 changeOnBlur 为 false 时不需要这个值，更新过于频繁
    if (changeOnBlur && value !== localValue) {
      setLocalValue(value);
    }
  }, [value, changeOnBlur]);

  // 修改组件库的默认行为：按回车失去焦点
  var handlePressEnter = useCallback(function (e) {
    e.currentTarget.blur();
    onPressEnter === null || onPressEnter === void 0 ? void 0 : onPressEnter(e);
  }, [onPressEnter]);

  // 根据配置决定是否需要聚焦自动选中输入框文本
  var handleFocus = useCallback(function (e) {
    if (autoSelect) {
      e.currentTarget.select();
    }
    onFocus === null || onFocus === void 0 ? void 0 : onFocus(e);
  }, [onFocus]);

  // changeOnBlur 为 true 模式下，修改的值存本地
  var handleChange = useCallback(function (value) {
    setLocalValue(value);
  }, [onChange]);

  // changeOnBlur 为 true 模式下，失去焦点的时候才提交值的修改
  var handleBlur = useCallback(function (e) {
    if (refValue.current !== undefined && refValue.current !== value) {
      if (enableEmpty || refValue.current !== '') {
        onChange === null || onChange === void 0 ? void 0 : onChange(refValue.current, e);
      } else {
        setLocalValue(value);
      }
    }
    onBlur === null || onBlur === void 0 ? void 0 : onBlur(e);
  }, [value, onBlur]);
  var halfControlledProps = (_halfControlledProps = {}, _defineProperty(_halfControlledProps, 'value' in props ? 'value' : 'defaultValue', localValue), _defineProperty(_halfControlledProps, "onChange", handleChange), _defineProperty(_halfControlledProps, "onBlur", handleBlur), _halfControlledProps);
  return /*#__PURE__*/_jsx(Input, _objectSpread(_objectSpread({
    ref: ref,
    onPressEnter: handlePressEnter,
    onFocus: handleFocus,
    className: classNames({
      'arco-input-borderless': !bordered
    }, className)
  }, changeOnBlur ? halfControlledProps : 'value' in props ? {
    value: value,
    onBlur: onBlur,
    onChange: onChange
  } : {
    defaultValue: defaultValue,
    onBlur: onBlur,
    onChange: onChange
  }), restProps));
});
var InputSearch = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var onSearch = _ref.onSearch,
    restProps = _objectWithoutProperties(_ref, _excluded2);
  return /*#__PURE__*/_jsx(XInput, _objectSpread({
    ref: ref,
    prefix: /*#__PURE__*/_jsx(SearchCircleOutlined, {}),
    onChange: onSearch
  }, restProps));
});
var InputTextArea = /*#__PURE__*/forwardRef(function (props, ref) {
  var _halfControlledProps2;
  var value = props.value,
    defaultValue = props.defaultValue,
    changeOnBlur = props.changeOnBlur,
    _props$bordered2 = props.bordered,
    bordered = _props$bordered2 === void 0 ? true : _props$bordered2,
    className = props.className,
    enableEmpty = props.enableEmpty,
    onBlur = props.onBlur,
    onChange = props.onChange,
    restProps = _objectWithoutProperties(props, _excluded3);

  // 用于 changeOnBlur 为 true 的模式，组件内存储，在失焦的时候，提交这个值
  var _useState3 = useState('value' in props ? value : defaultValue),
    _useState4 = _slicedToArray(_useState3, 2),
    localValue = _useState4[0],
    setLocalValue = _useState4[1];

  // 为了让 onBlur 函数不要每次值更新都生成新的函数引用，这里用 ref 缓存 localValue 值，这样 onBlur 函数可以不依赖 localValue 的更新，直接在需要的时候读取 ref 的值
  var refValue = useRef(localValue);
  refValue.current = localValue;
  useEffect(function () {
    // 只在 changeOnBlur 为 true 的时候 value 变化才更新，防止 changeOnBlur 为 false 时不需要这个值，更新过于频繁
    if (changeOnBlur && value !== localValue) {
      setLocalValue(value);
    }
  }, [value, changeOnBlur]);

  // changeOnBlur 为 true 模式下，修改的值存本地
  var handleChange = useCallback(function (value) {
    setLocalValue(value);
  }, [onChange]);

  // changeOnBlur 为 true 模式下，失去焦点的时候才提交值的修改
  var handleBlur = useCallback(function (e) {
    if (refValue.current !== undefined && refValue.current !== value) {
      if (enableEmpty || refValue.current !== '') {
        onChange === null || onChange === void 0 ? void 0 : onChange(refValue.current, e);
      } else {
        setLocalValue(value);
      }
    }
    onBlur === null || onBlur === void 0 ? void 0 : onBlur(e);
  }, [value, onBlur]);
  var halfControlledProps = (_halfControlledProps2 = {}, _defineProperty(_halfControlledProps2, 'value' in props ? 'value' : 'defaultValue', localValue), _defineProperty(_halfControlledProps2, "onChange", handleChange), _defineProperty(_halfControlledProps2, "onBlur", handleBlur), _halfControlledProps2);
  return /*#__PURE__*/_jsx(Input.TextArea, _objectSpread(_objectSpread({
    ref: ref,
    className: classNames({
      'arco-textarea-borderless': !bordered
    }, className)
  }, changeOnBlur ? halfControlledProps : 'value' in props ? {
    value: value,
    onBlur: onBlur,
    onChange: onChange
  } : {
    defaultValue: defaultValue,
    onBlur: onBlur,
    onChange: onChange
  }), restProps));
});
export default XInput;
XInput.Search = InputSearch;
XInput.TextArea = InputTextArea;
XInput.Password = Input.Password;
XInput.Group = Input.Group;