import type { InputProps } from '@arco-design/web-react';
import type { InputSearchProps, RefInputType, RefTextAreaType, TextAreaProps } from '@arco-design/web-react/es/Input';
interface BaseInputProps {
    /** 显示边框 */
    bordered?: boolean;
    /**  是否失去焦点时，触发 onChange 事件 */
    changeOnBlur?: boolean;
}
interface XInputProps extends InputProps, BaseInputProps {
    /**  是否允许文本为空 */
    enableEmpty?: boolean;
    /**  是否聚焦后自动选中输入框的文本 */
    autoSelect?: boolean;
    onChange?: (value: string, e: any) => void;
}
interface XInputSearchProps extends InputSearchProps, BaseInputProps {
}
interface XTextAreaProps extends TextAreaProps, BaseInputProps {
    /**  是否允许文本为空 */
    enableEmpty?: boolean;
}
export type { XInputProps as InputProps, XInputSearchProps as InputSearchProps, RefInputType, RefTextAreaType, XTextAreaProps as TextAreaProps, };
