function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { Fragment, cloneElement, useMemo, useRef, useState } from 'react';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export function PointerDrag(_ref) {
  var children = _ref.children,
    onMoveStart = _ref.onMoveStart,
    onMove = _ref.onMove,
    onMoveEnd = _ref.onMoveEnd;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    dragging = _useState2[0],
    setDrag = _useState2[1];
  var _useState3 = useState({
      x: 0,
      y: 0
    }),
    _useState4 = _slicedToArray(_useState3, 2),
    position = _useState4[0],
    setPosition = _useState4[1];
  var windowSize = useMemo(function () {
    return {
      width: document.body.clientWidth,
      height: document.body.clientHeight
    };
  }, []);
  var moveDistance = useRef(0);
  var onMouseDown = function onMouseDown(e) {
    e.target.requestPointerLock();
    setPosition({
      x: e.clientX,
      y: e.clientY
    });
    setDrag(true);
    moveDistance.current = 0;
    onMoveStart === null || onMoveStart === void 0 ? void 0 : onMoveStart();
  };
  var _onMouseMove = function onMouseMove(e) {
    if (dragging) {
      setPosition(function (prev) {
        var nextX = prev.x + e.movementX;
        nextX = nextX + 10 * windowSize.width % windowSize.width;
        return {
          x: nextX,
          y: prev.y
        };
      });
      // 记录移动距离
      moveDistance.current = moveDistance.current + e.movementX;
      onMove === null || onMove === void 0 ? void 0 : onMove({
        movementX: moveDistance.current
      });
    } else if (Math.abs(e.movementX) >= 1 && e.buttons) {
      onMouseDown(e);
    }
  };
  var onMouseUp = function onMouseUp() {
    if (dragging) {
      document.exitPointerLock();
      setDrag(false);
      onMoveEnd === null || onMoveEnd === void 0 ? void 0 : onMoveEnd({
        movementX: moveDistance.current
      });
    }
  };
  var arrow = /*#__PURE__*/_jsx("svg", {
    width: 46,
    height: 15,
    style: {
      position: 'fixed',
      left: position.x,
      top: position.y,
      width: 46,
      height: 15,
      zIndex: 1,
      transform: 'translate(-50%, -50%)'
    },
    children: /*#__PURE__*/_jsxs("g", {
      transform: "translate(2 3)",
      children: [/*#__PURE__*/_jsx("path", {
        fillRule: "evenodd",
        d: "M 15 4.5L 15 2L 11.5 5.5L 15 9L 15 6.5L 31 6.5L 31 9L 34.5 5.5L 31 2L 31 4.5Z",
        stroke: "#fafafa",
        style: {
          strokeWidth: 2
        }
      }), /*#__PURE__*/_jsx("path", {
        fillRule: "evenodd",
        d: "M 15 4.5L 15 2L 11.5 5.5L 15 9L 15 6.5L 31 6.5L 31 9L 34.5 5.5L 31 2L 31 4.5Z"
      })]
    })
  });
  return /*#__PURE__*/_jsxs(Fragment, {
    children: [children && /*#__PURE__*/cloneElement(children, {
      onMouseMove: function onMouseMove(e) {
        e.persist();
        _onMouseMove(e);
      },
      onMouseUp: onMouseUp
    }), dragging && arrow]
  });
}