function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["min", "max", "step", "precision", "value", "defaultValue", "prefix", "suffix", "hideControl", "onChange", "onPointMoveStart", "onPointMoveEnd", "onBlur"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { forwardRef, useCallback, useEffect, useRef, useState } from 'react';
import { DownOutlined, UpOutlined } from '@easyv/react-icons';
import classNames from 'classnames';
import Input from "../Input";
import { getSafeValue, evaluateExpression } from "./util";
import { PointerDrag } from "./PointDrag";
import "./index.less";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var valueRegx = /^[0-9().+\-*/]+$/;
var InputNumber = /*#__PURE__*/forwardRef(function (props, ref) {
  var min = props.min,
    max = props.max,
    _props$step = props.step,
    step = _props$step === void 0 ? 1 : _props$step,
    precision = props.precision,
    value = props.value,
    defaultValue = props.defaultValue,
    prefix = props.prefix,
    suffix = props.suffix,
    hideControl = props.hideControl,
    onChange = props.onChange,
    onPointMoveStart = props.onPointMoveStart,
    onPointMoveEnd = props.onPointMoveEnd,
    onBlur = props.onBlur,
    restProps = _objectWithoutProperties(props, _excluded);
  var getPropsValue = function getPropsValue() {
    if ('value' in props) {
      return value === undefined ? value : value.toString();
    } else {
      return defaultValue === undefined ? defaultValue : defaultValue.toString();
    }
  };
  var _useState = useState(getPropsValue),
    _useState2 = _slicedToArray(_useState, 2),
    localValue = _useState2[0],
    setLocalValue = _useState2[1];

  // 给拖拽滑动改变数值使用
  var dragRef = useRef(false);
  var originValue = useRef();
  useEffect(function () {
    // 拖拽过程中禁止更新
    if (!dragRef.current && value !== localValue) {
      setLocalValue(getPropsValue());
    }
  }, [value]);

  // 只允许输入数字和(.+-*/)
  var handleChange = useCallback(function (value) {
    if (value === '' || valueRegx.test(value)) {
      setLocalValue(value);
    }
  }, []);
  var handleBlur = function handleBlur(e) {
    var result;
    if (localValue !== undefined) {
      result = evaluateExpression(localValue);
      if (isNaN(result)) {
        setLocalValue(getPropsValue());
        return;
      }
      result = getSafeValue(result, {
        min: min,
        max: max,
        precision: precision
      });
      setLocalValue(result.toString());
      if (result !== value) {
        onChange === null || onChange === void 0 ? void 0 : onChange(result);
      }
    }
    onBlur === null || onBlur === void 0 ? void 0 : onBlur(e, result);
  };
  var handleMoveStart = function handleMoveStart() {
    dragRef.current = true;
    var initValue = getPropsValue();
    var val = initValue === undefined ? undefined : isNaN(Number(initValue)) ? undefined : Number(initValue);
    originValue.current = val;
    onPointMoveStart === null || onPointMoveStart === void 0 ? void 0 : onPointMoveStart(val);
  };
  var handlePointMove = function handlePointMove(_ref) {
    var movementX = _ref.movementX;
    var initNumberValue = originValue.current;
    if (initNumberValue === undefined) {
      initNumberValue = 0;
    }
    var result = initNumberValue + Math.floor(movementX / 2) * step;
    result = getSafeValue(result, {
      min: min,
      max: max,
      precision: precision
    });
    setLocalValue(result.toString());
    if (result !== originValue.current) {
      onChange === null || onChange === void 0 ? void 0 : onChange(result);
    }
  };
  var handlePointMoveEnd = function handlePointMoveEnd() {
    dragRef.current = false;
    onPointMoveEnd === null || onPointMoveEnd === void 0 ? void 0 : onPointMoveEnd(+localValue);
  };
  var handleCountUp = function handleCountUp() {
    if (props.disabled) {
      return;
    }
    var result = localValue === undefined ? 0 : isNaN(Number(localValue)) ? 0 : Number(localValue);
    result += step;
    result = getSafeValue(result, {
      min: min,
      max: max,
      precision: precision
    });
    setLocalValue(result.toString());
    if (result !== value) {
      onChange === null || onChange === void 0 ? void 0 : onChange(result);
    }
  };
  var handleCountDown = function handleCountDown() {
    if (props.disabled) {
      return;
    }
    var result = localValue === undefined ? 0 : isNaN(Number(localValue)) ? 0 : Number(localValue);
    result -= step;
    result = getSafeValue(result, {
      min: min,
      max: max,
      precision: precision
    });
    setLocalValue(result.toString());
    if (result !== value) {
      onChange === null || onChange === void 0 ? void 0 : onChange(result);
    }
  };
  return /*#__PURE__*/_jsx(Input, _objectSpread({
    autoSelect: true,
    ref: ref,
    className: "arco-input-number",
    onChange: handleChange,
    onBlur: handleBlur,
    value: localValue,
    prefix: !props.disabled && !props.readOnly ? /*#__PURE__*/_jsx(PointerDrag, {
      onMoveStart: handleMoveStart,
      onMove: handlePointMove,
      onMoveEnd: handlePointMoveEnd,
      children: /*#__PURE__*/_jsx("span", {
        className: "arco-input-number-prefix-inner",
        children: prefix
      })
    }) : /*#__PURE__*/_jsx("span", {
      className: "arco-input-number-prefix-inner",
      children: prefix
    }),
    suffix: /*#__PURE__*/_jsxs("div", {
      className: "arco-input-number-suffix-inner",
      children: [/*#__PURE__*/_jsx("div", {
        className: "arco-input-number-suffix-icon",
        children: suffix
      }), !hideControl && !props.disabled && !props.readOnly && /*#__PURE__*/_jsxs("div", {
        className: "arco-input-number-step",
        children: [/*#__PURE__*/_jsx("span", {
          className: classNames('arco-input-number-handle-up', {
            'arco-input-number-handle-disabled': localValue !== undefined && max !== undefined && +localValue >= max
          }),
          onClick: handleCountUp,
          children: /*#__PURE__*/_jsx(UpOutlined, {})
        }), /*#__PURE__*/_jsx("span", {
          className: classNames('arco-input-number-handle-down', {
            'arco-input-number-handle-disabled': localValue !== undefined && min !== undefined && +localValue <= min
          }),
          onClick: handleCountDown,
          children: /*#__PURE__*/_jsx(DownOutlined, {})
        })]
      })]
    })
  }, restProps));
});
export default InputNumber;