/// <reference types="react" />
import type { InputNumberProps } from '@arco-design/web-react';
interface XInputNumberProps extends Omit<InputNumberProps, 'value' | 'defaultValue' | 'onKeyDown' | 'formatter' | 'parser' | 'strictMode' | 'mode' | 'icons' | 'onBlur'> {
    value?: number;
    defaultValue?: number;
    bordered?: boolean;
    onKeyDown?: (e: React.KeyboardEvent<HTMLInputElement>) => void;
    onPressEnter?: (e: React.KeyboardEvent<HTMLInputElement>) => void;
    onPointMoveStart?: (value?: number) => void;
    onPointMoveEnd?: (value: number) => number;
    onBlur?: (e: any, value?: number) => void;
}
export { XInputNumberProps as InputNumberProps };
