function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useState, useEffect, forwardRef, useRef } from 'react';
import classNames from 'classnames';
import { useLocalStorageState } from 'ahooks';
import { DownOutlined, SwapOutlined } from '@easyv/react-icons';
import SpaceModal from "../SpaceModal";
import { useClickOutside } from "../hooks";
import Points from "./Points";
import ColorPicker from "../ColorPicker/Panel";
import Button from "../Button";
import "../ColorPicker/index.less";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
function CustomColorPicker(_ref, ref) {
  var color = _ref.color,
    position = _ref.position,
    onChange = _ref.onChange,
    onCancel = _ref.onCancel;
  var _useLocalStorageState = useLocalStorageState('usedColors'),
    _useLocalStorageState2 = _slicedToArray(_useLocalStorageState, 1),
    usedPureColors = _useLocalStorageState2[0];
  var _useLocalStorageState3 = useLocalStorageState('usedLinearColors'),
    _useLocalStorageState4 = _slicedToArray(_useLocalStorageState3, 1),
    usedLinearColors = _useLocalStorageState4[0];
  var _useLocalStorageState5 = useLocalStorageState('recentCollapsed'),
    _useLocalStorageState6 = _slicedToArray(_useLocalStorageState5, 2),
    recentCollapsed = _useLocalStorageState6[0],
    setRecentCollapsed = _useLocalStorageState6[1];
  var _useState = useState(0),
    _useState2 = _slicedToArray(_useState, 2),
    active = _useState2[0],
    setActive = _useState2[1];
  var _useState3 = useState(''),
    _useState4 = _slicedToArray(_useState3, 2),
    localColor = _useState4[0],
    setLocalColor = _useState4[1];
  var lastColorRef = useRef(null);
  var currentColor = color[active] ? color[active].color : '#fff';
  useEffect(function () {
    setLocalColor(currentColor);
  }, [currentColor]);
  useClickOutside(ref, onCancel);
  useEffect(function () {
    return function () {
      var lastColor = lastColorRef.current;
      if (lastColor) {
        if (typeof lastColor === 'string') {
          var newColors = [lastColor].concat(usedPureColors || []);
          newColors = Array.from(new Set(newColors)).slice(0, 16);
          localStorage.setItem('usedColors', JSON.stringify(newColors));
        } else {
          var _newColors = [lastColor].concat(usedLinearColors || []);
          _newColors = _newColors.slice(0, 16);
          localStorage.setItem('usedLinearColors', JSON.stringify(_newColors));
        }
      }
    };
  }, []);
  useEffect(function () {
    var downHandler = function downHandler(e) {
      e.stopPropagation();
      if (e.key === 'Backspace') {
        if (color.length > 2) {
          var resultColor = color.filter(function (d, i) {
            return i !== active;
          });
          setActive(active > 0 ? active - 1 : 0);
          onChange(resultColor);
        }
      }
    };
    document.body.addEventListener('keydown', downHandler);
    return function () {
      document.body.removeEventListener('keydown', downHandler);
    };
  }, [color, active]);
  var handleColorChange = function handleColorChange(colorValue, used) {
    // 判断颜色有没有更改，没有更改就不要执行。进来的第一次会把焦点定位到输入框中，点击其他地方时会失焦，会自动触发ColorPicker中的onchange事件，导致更新一次
    if (!color[active]) {
      return;
    }
    if (color[active].color.replace(/\s/g, '') === colorValue) {
      return;
    }
    // console.log(colorValue, 'colorValue');
    var newColors = color.map(function (d, i) {
      return i === active ? _objectSpread(_objectSpread({}, d), {}, {
        color: colorValue
      }) : d;
    });
    // ref.current._lastColor = used ? null : newColors;
    lastColorRef.current = used ? null : colorValue;
    // 增加一个定时器，延迟更新。点击最近使用的颜色时也会触发ColorPicker中的onChange事件，由于ColorPicker中的onChange事件有个100毫秒的延迟，所以给这个设置为101毫秒的延迟，主要目的是在ColorPicker中的onChange事件之后触发
    setTimeout(function () {
      onChange(newColors);
    }, 101);
  };
  var handleCollapseRecent = function handleCollapseRecent() {
    setRecentCollapsed(function (prev) {
      return !prev;
    });
  };
  var handleColorsChange = function handleColorsChange(colors, used) {
    onChange(colors);
    lastColorRef.current = used ? null : colors;
  };

  // 切换dot的排列方向
  var handleReverseColor = function handleReverseColor() {
    var copyStops = color.slice();
    var newStops = copyStops.reduce(function (all, item) {
      var obj = {};
      obj['offset'] = 100 - item.offset;
      obj['color'] = item.color;
      all.push(obj);
      return all;
    }, []);
    onChange(newStops);
  };
  return /*#__PURE__*/_jsx(SpaceModal, {
    children: /*#__PURE__*/_jsxs("div", {
      className: 'arco-color-picker',
      style: {
        left: position.x,
        top: position.y
      },
      ref: ref,
      children: [/*#__PURE__*/_jsxs("div", {
        className: 'arco-color-picker-colors',
        children: [/*#__PURE__*/_jsx(Points, {
          dots: color,
          active: active,
          setActive: setActive,
          onChange: handleColorsChange
        }), /*#__PURE__*/_jsx("div", {
          style: {
            flex: 1
          },
          children: /*#__PURE__*/_jsx(Button, {
            onClick: handleReverseColor,
            children: /*#__PURE__*/_jsx(SwapOutlined, {})
          })
        })]
      }), /*#__PURE__*/_jsxs("div", {
        className: 'arco-color-picker-scroll-container',
        children: [/*#__PURE__*/_jsx(ColorPicker, {
          color: localColor,
          onChange: handleColorChange
        }), /*#__PURE__*/_jsxs("div", {
          className: 'arco-color-picker-recent',
          children: [/*#__PURE__*/_jsxs("div", {
            className: 'arco-color-picker-title',
            onClick: handleCollapseRecent,
            children: [/*#__PURE__*/_jsx("div", {
              children: "\u6700\u8FD1\u4F7F\u7528"
            }), /*#__PURE__*/_jsx(DownOutlined, {
              className: classNames('arco-color-picker-icon', _defineProperty({}, 'arco-color-picker-collapsed', recentCollapsed))
            })]
          }), !recentCollapsed && /*#__PURE__*/_jsx("div", {
            className: 'arco-color-picker-list',
            children: usedPureColors && usedPureColors.map(function (d) {
              return /*#__PURE__*/_jsx("div", {
                className: 'arco-color-picker-item',
                style: {
                  background: d
                },
                onClick: function onClick() {
                  return handleColorChange(d, true);
                }
              }, d);
            })
          })]
        })]
      })]
    })
  });
}
export default /*#__PURE__*/forwardRef(CustomColorPicker);