function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useState, useRef, useEffect, useDeferredValue } from 'react';
import ColorPicker from "./Panel";
import { getBackgroundAccordingColor } from "../ColorPicker/utils";
import "./index.less";
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function RangeColor(_ref) {
  var value = _ref.value,
    onChange = _ref.onChange;
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    show = _useState2[0],
    setShow = _useState2[1];
  var _useState3 = useState({
      x: 0,
      y: 0
    }),
    _useState4 = _slicedToArray(_useState3, 2),
    position = _useState4[0],
    setPosition = _useState4[1];
  var previewRef = useRef(null);
  var pickerRef = useRef(null);
  var deferedShow = useDeferredValue(show);
  var handleClick = function handleClick() {
    setShow(true);
  };
  var handleHide = function handleHide() {
    setShow(false);
  };
  var handleColorChange = function handleColorChange(value) {
    onChange(value);
  };
  useEffect(function () {
    if (deferedShow) {
      var targetRect = previewRef.current.getBoundingClientRect();
      var pickerRect = pickerRef.current.getBoundingClientRect();
      var windowHeight = document.documentElement.clientHeight;
      var windowWidth = document.documentElement.clientWidth;
      var hexDOM = pickerRef.current.querySelector('.rc-color-picker-panel-params-hex');
      if (hexDOM) {
        hexDOM.focus();
        hexDOM.select();
      }
      var top = windowHeight - targetRect.bottom < pickerRect.height ? targetRect.top - pickerRect.height < 0 ? 0 : targetRect.top - pickerRect.height : targetRect.bottom;
      var left = windowWidth - targetRect.left < pickerRect.width ? windowWidth - pickerRect.width : targetRect.left;
      setPosition({
        x: left,
        y: top
      });
    }
  }, [deferedShow]);
  return /*#__PURE__*/_jsxs(_Fragment, {
    children: [/*#__PURE__*/_jsx("span", {
      className: 'arco-range-color-preview',
      onClick: handleClick,
      ref: previewRef,
      children: /*#__PURE__*/_jsx("span", {
        className: 'arco-range-color-inner',
        style: getBackgroundAccordingColor(value, 90)
      })
    }), deferedShow && /*#__PURE__*/_jsx(ColorPicker, {
      ref: pickerRef,
      color: value,
      position: position,
      onCancel: handleHide,
      onChange: handleColorChange
    })]
  });
}