import { useEffect } from 'react';
export function useClickOutside(ref, handler) {
  useEffect(function () {
    var listener = function listener(event) {
      if (!ref.current || ref.current.contains(event.target)) {
        return;
      }
      handler(event);
    };
    document.addEventListener('click', listener);
    return function () {
      document.removeEventListener('click', listener);
    };
  }, [ref, handler]);
  return null;
}